%{

/*
   sys.y -- PIKT piktc parser for the systems.cfg file

   $Header: /home/cvs/ucgsb/pikt/src/piktc/sys.y,v 1.14 2000/10/06 21:44:29 berto Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-2000 by Robert Osterlund.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   Send problem reports, bouquets and brickbats to:

   robert.osterlund@gsb.uchicago.edu

   Robert Osterlund
   Graduate School of Business
   University of Chicago
   1101 E. 58th Street, W309
   Chicago, IL 60637
   USA
 */

#include "../lib/common.h"
#include "piktc.h"

ident *sidp;

%}

%union {
	char *sval;
}

%token <sval> _STANZA _HOST
%token _HOSTS _MEMBERS _ALIASES

%%

start:		systanzas
		;

systanzas:	systanza
		| systanzas systanza
		;

systanza:	system
		| alias
		| group
		;

system:		_STANZA {
			if (! prescan)
				sidp = regident($1, OPS, FALSE);
			else
				opsysnum++;
		}
		_HOSTS
		systemhosts
		;

alias:		_STANZA {
			if (! prescan)
				hostcurr = $1;
		}
		_ALIASES
		aliashosts {
			if (! prescan)
				free($1);
		}
		;

group:		_STANZA {
			if (! prescan)
				sidp = regident($1, GRP, FALSE);
			else
				hstgrpnum++;
		}
		_MEMBERS
		grouphosts
		;

systemhosts:	/* empty */
		| syshosts
		;

syshosts:	syshost
		| syshosts syshost
		;

aliashosts:	/* empty */
		| alshosts
		;

alshosts:	alshost
		| alshosts alshost
		;

grouphosts:	/* empty */
		| grphosts
		;

grphosts:	grphost
		| grphosts grphost
		;

syshost:	_HOST {
			if (! prescan) {
				sidp = regident($1, HST, FALSE);
				insert($1, HST);
			} else
				hostnum++;
		}

alshost:	_HOST {
			if (! prescan)
				sidp = regident($1, ALS, FALSE);
		}

grphost:	_HOST {
			if (! prescan) {
				insert($1, HST);  /* or OPS, GRP, or ALS */
				free($1);
			}
		}

%%
